"use strict";

/* Copyright (c) 2015-2017 APDM, Inc.
 *
 * default_user_options.js
 *
 * Default options for the Mobility Lab v2 application.
 */

/* jshint unused: false */

/**
 * Default options for patient, if none exist.
 */
var defaultPatientOptions = {
  requiredFields: {
    id: true,
    name: false,
    height: false,
    birthYear: false,
    birthMonth: false,
    birthDay: false
  }
};
/**
 * Default metric selection groups.
 */

var defaultMetricSelections = {
  "default": {
    displayName: "Default",
    selections: {
      "Walk": ["Duration", "Gait/Lower Limb/Cadence", "Gait/Lower Limb/Gait Cycle Duration", "Gait/Lower Limb/Gait Speed", "Gait/Lower Limb/Double Support", "Gait/Lower Limb/Terminal Double Support", "Gait/Lower Limb/Elevation at Midswing", "Gait/Lower Limb/Lateral Step Variability", "Gait/Lower Limb/Lateral Swing Max", "Gait/Lower Limb/Pitch at Initial Contact", "Gait/Lower Limb/Pitch at Toe Off", "Gait/Lower Limb/Stance", "Gait/Lower Limb/Step Duration", "Gait/Lower Limb/Stride Length", "Gait/Lower Limb/Swing", "Gait/Lower Limb/Toe Out Angle", "Gait/Upper Limb/Maximum Velocity", "Gait/Upper Limb/Range of Motion", "Gait/Lumbar/Coronal Range of Motion", "Gait/Lumbar/Sagittal Range of Motion", "Gait/Lumbar/Transverse Range of Motion", "Gait/Trunk/Coronal Range of Motion", "Gait/Trunk/Sagittal Range of Motion", "Gait/Trunk/Transverse Range of Motion", "Turns/Angle", "Turns/Duration", "Turns/Peak Velocity", "Turns/Steps", "Anticipatory Postural Adjustment/APA Duration", "Anticipatory Postural Adjustment/First Step Duration", "Anticipatory Postural Adjustment/First Step Range of Motion", "Anticipatory Postural Adjustment/Maximum AP Acceleration", "Anticipatory Postural Adjustment/Maximum ML Acceleration"],
      "Sway": ["Postural Sway/Angles/Duration", "Postural Sway/Angles/95% Ellipse Sway Area", "Postural Sway/Angles/RMS Sway", "Postural Sway/Angles/RMS Sway (Coronal)", "Postural Sway/Angles/RMS Sway (Sagittal)", "Postural Sway/Acc/95% Ellipse Sway Area", "Postural Sway/Acc/RMS Sway", "Postural Sway/Acc/RMS Sway (Coronal)", "Postural Sway/Acc/RMS Sway (Sagittal)", "Postural Sway/Acc/Centroidal Frequency", "Postural Sway/Acc/Centroidal Frequency (Coronal)", "Postural Sway/Acc/Centroidal Frequency (Sagittal)", "Postural Sway/Acc/Frequency Dispersion", "Postural Sway/Acc/Frequency Dispersion (Coronal)", "Postural Sway/Acc/Frequency Dispersion (Sagittal)", "Postural Sway/Acc/Jerk", "Postural Sway/Acc/Jerk (Coronal)", "Postural Sway/Acc/Jerk (Sagittal)", "Postural Sway/Acc/Mean Velocity", "Postural Sway/Acc/Mean Velocity (Coronal)", "Postural Sway/Acc/Mean Velocity (Sagittal)", "Postural Sway/Acc/Path Length", "Postural Sway/Acc/Path Length (Coronal)", "Postural Sway/Acc/Path Length (Sagittal)", "Postural Sway/Acc/Range", "Postural Sway/Acc/Range (Coronal)", "Postural Sway/Acc/Range (Sagittal)"],
      "TUG": ["Duration", "Turns/Angle", "Turns/Duration", "Turns/Peak Velocity", "Sit to Stand/Duration", "Sit to Stand/Lean Angle", "Stand to Sit/Duration", "Stand to Sit/Lean Angle"],
      "SAW": ["Gait/Lower Limb/Cadence", "Gait/Lower Limb/Gait Cycle Duration", "Gait/Lower Limb/Gait Speed", "Gait/Lower Limb/Double Support", "Gait/Lower Limb/Terminal Double Support", "Gait/Lower Limb/Elevation at Midswing", "Gait/Lower Limb/Lateral Step Variability", "Gait/Lower Limb/Lateral Swing Max", "Gait/Lower Limb/Pitch at Initial Contact", "Gait/Lower Limb/Pitch at Toe Off", "Gait/Lower Limb/Stance", "Gait/Lower Limb/Step Duration", "Gait/Lower Limb/Stride Length", "Gait/Lower Limb/Swing", "Gait/Lower Limb/Toe Out Angle", "Gait/Upper Limb/Maximum Velocity", "Gait/Upper Limb/Range of Motion", "Gait/Lumbar/Coronal Range of Motion", "Gait/Lumbar/Sagittal Range of Motion", "Gait/Lumbar/Transverse Range of Motion", "Gait/Trunk/Coronal Range of Motion", "Gait/Trunk/Sagittal Range of Motion", "Gait/Trunk/Transverse Range of Motion", "Turns/Angle", "Turns/Duration", "Turns/Peak Velocity", "Turns/Steps", "Anticipatory Postural Adjustment/APA Duration", "Anticipatory Postural Adjustment/First Step Duration", "Anticipatory Postural Adjustment/First Step Range of Motion", "Anticipatory Postural Adjustment/Maximum AP Acceleration", "Anticipatory Postural Adjustment/Maximum ML Acceleration", "Postural Sway/Angles/Duration", "Postural Sway/Angles/95% Ellipse Sway Area", "Postural Sway/Angles/RMS Sway", "Postural Sway/Angles/RMS Sway (Coronal)", "Postural Sway/Angles/RMS Sway (Sagittal)", "Postural Sway/Acc/95% Ellipse Sway Area", "Postural Sway/Acc/RMS Sway", "Postural Sway/Acc/RMS Sway (Coronal)", "Postural Sway/Acc/RMS Sway (Sagittal)", "Postural Sway/Acc/Centroidal Frequency", "Postural Sway/Acc/Centroidal Frequency (Coronal)", "Postural Sway/Acc/Centroidal Frequency (Sagittal)", "Postural Sway/Acc/Frequency Dispersion", "Postural Sway/Acc/Frequency Dispersion (Coronal)", "Postural Sway/Acc/Frequency Dispersion (Sagittal)", "Postural Sway/Acc/Jerk", "Postural Sway/Acc/Jerk (Coronal)", "Postural Sway/Acc/Jerk (Sagittal)", "Postural Sway/Acc/Mean Velocity", "Postural Sway/Acc/Mean Velocity (Coronal)", "Postural Sway/Acc/Mean Velocity (Sagittal)", "Postural Sway/Acc/Path Length", "Postural Sway/Acc/Path Length (Coronal)", "Postural Sway/Acc/Path Length (Sagittal)", "Postural Sway/Acc/Range", "Postural Sway/Acc/Range (Coronal)", "Postural Sway/Acc/Range (Sagittal)"],
      "Sit to Stand": ["Duration", "Sit to Stand/Duration", "Sit to Stand/Lean Angle", "Stand to Sit/Duration", "Stand to Sit/Lean Angle"],
      "360 Degree Turn": ["Turns/Angle", "Turns/Duration", "Turns/Peak Velocity"],
      "This is my new test type": ["Duration"],
      "MLK Walk": ["Duration", "Gait/Lower Limb/Cadence", "Gait/Lower Limb/Gait Cycle Duration", "Gait/Lower Limb/Gait Speed", "Gait/Lower Limb/Double Support", "Gait/Lower Limb/Terminal Double Support", "Gait/Lower Limb/Elevation at Midswing", "Gait/Lower Limb/Lateral Step Variability", "Gait/Lower Limb/Lateral Swing Max", "Gait/Lower Limb/Pitch at Initial Contact", "Gait/Lower Limb/Pitch at Toe Off", "Gait/Lower Limb/Stance", "Gait/Lower Limb/Step Duration", "Gait/Lower Limb/Stride Length", "Gait/Lower Limb/Swing", "Gait/Lower Limb/Toe Out Angle", "Gait/Upper Limb/Maximum Velocity", "Gait/Upper Limb/Range of Motion", "Gait/Lumbar/Coronal Range of Motion", "Gait/Lumbar/Sagittal Range of Motion", "Gait/Lumbar/Transverse Range of Motion", "Gait/Trunk/Coronal Range of Motion", "Gait/Trunk/Sagittal Range of Motion", "Gait/Trunk/Transverse Range of Motion", "Turns/Angle", "Turns/Duration", "Turns/Peak Velocity", "Turns/Steps", "Anticipatory Postural Adjustment/APA Duration", "Anticipatory Postural Adjustment/First Step Duration", "Anticipatory Postural Adjustment/First Step Range of Motion", "Anticipatory Postural Adjustment/Maximum AP Acceleration", "Anticipatory Postural Adjustment/Maximum ML Acceleration", "Gait/Joint/Neck/Abduction/Minimum", "Gait/Joint/Neck/Abduction/Maximum", "Gait/Joint/Neck/Abduction/ROM", "Gait/Joint/Neck/Flexion/Minimum", "Gait/Joint/Neck/Flexion/Maximum", "Gait/Joint/Neck/Flexion/ROM", "Gait/Joint/Neck/Rotation/Minimum", "Gait/Joint/Neck/Rotation/Maximum", "Gait/Joint/Neck/Rotation/ROM", "Gait/Joint/Trunk/Abduction/Minimum", "Gait/Joint/Trunk/Abduction/Maximum", "Gait/Joint/Trunk/Abduction/ROM", "Gait/Joint/Back/Abduction/Minimum", "Gait/Joint/Back/Abduction/Maximum", "Gait/Joint/Back/Abduction/ROM", "Gait/Joint/Back/Flexion/Minimum", "Gait/Joint/Back/Flexion/Maximum", "Gait/Joint/Back/Flexion/ROM", "Gait/Joint/Back/Rotation/Minimum", "Gait/Joint/Back/Rotation/Maximum", "Gait/Joint/Back/Rotation/ROM", "Gait/Joint/Clavicle/Abduction/Minimum", "Gait/Joint/Clavicle/Abduction/Maximum", "Gait/Joint/Clavicle/Abduction/ROM", "Gait/Joint/Clavicle/Flexion/Minimum", "Gait/Joint/Clavicle/Flexion/Maximum", "Gait/Joint/Clavicle/Flexion/ROM", "Gait/Joint/Clavicle/Rotation/Minimum", "Gait/Joint/Clavicle/Rotation/Maximum", "Gait/Joint/Clavicle/Rotation/ROM", "Gait/Joint/Shoulder/Abduction/Minimum", "Gait/Joint/Shoulder/Abduction/Maximum", "Gait/Joint/Shoulder/Abduction/ROM", "Gait/Joint/Shoulder/Flexion/Minimum", "Gait/Joint/Shoulder/Flexion/Maximum", "Gait/Joint/Shoulder/Flexion/ROM", "Gait/Joint/Shoulder/Rotation/Minimum", "Gait/Joint/Shoulder/Rotation/Maximum", "Gait/Joint/Shoulder/Rotation/ROM", "Gait/Joint/Elbow/Flexion/Minimum", "Gait/Joint/Elbow/Flexion/Maximum", "Gait/Joint/Elbow/Flexion/ROM", "Gait/Joint/Elbow/Rotation/Minimum", "Gait/Joint/Elbow/Rotation/Maximum", "Gait/Joint/Elbow/Rotation/ROM", "Gait/Joint/Wrist/Abduction/Minimum", "Gait/Joint/Wrist/Abduction/Maximum", "Gait/Joint/Wrist/Abduction/ROM", "Gait/Joint/Wrist/Flexion/Minimum", "Gait/Joint/Wrist/Flexion/Maximum", "Gait/Joint/Wrist/Flexion/ROM", "Gait/Joint/Hip/Abduction/Minimum", "Gait/Joint/Hip/Abduction/Maximum", "Gait/Joint/Hip/Abduction/ROM", "Gait/Joint/Hip/Flexion/Minimum", "Gait/Joint/Hip/Flexion/Maximum", "Gait/Joint/Hip/Flexion/ROM", "Gait/Joint/Hip/Rotation/Minimum", "Gait/Joint/Hip/Rotation/Maximum", "Gait/Joint/Hip/Rotation/ROM", "Gait/Joint/Knee/Abduction/Minimum", "Gait/Joint/Knee/Abduction/Maximum", "Gait/Joint/Knee/Abduction/ROM", "Gait/Joint/Knee/Flexion/Minimum", "Gait/Joint/Knee/Flexion/Maximum", "Gait/Joint/Knee/Flexion/ROM", "Gait/Joint/Knee/Rotation/Minimum", "Gait/Joint/Knee/Rotation/Maximum", "Gait/Joint/Knee/Rotation/ROM", "Gait/Joint/Ankle/Abduction/Minimum", "Gait/Joint/Ankle/Abduction/Maximum", "Gait/Joint/Ankle/Abduction/ROM", "Gait/Joint/Ankle/Flexion/Minimum", "Gait/Joint/Ankle/Flexion/Maximum", "Gait/Joint/Ankle/Flexion/ROM", "Gait/Joint/Ankle/Rotation/Minimum", "Gait/Joint/Ankle/Rotation/Maximum", "Gait/Joint/Ankle/Rotation/ROM"],
      "Free Form": ["Duration"],
      "Custom Test": ["Duration"]
    }
  }
};
//# sourceMappingURL=default_user_options.js.map
