"use strict";

/* Copyright (c) 2016-2018 APDM, Inc.
 *
 * main.js
 *
 * RequireJS start script for Mobility Lab v2.
 */
requirejs.config({
  baseUrl: '/static/javascript',
  // NOTE: This is needed to make sure that jQuery is available to
  // bootstrap before it loads.
  shim: {
    'bootstrap': {
      deps: ['jquery']
    },
    'BVHLoader': {
      deps: ['three']
    },
    'OrbitControls': {
      deps: ['three']
    },
    'd3': {
      deps: ['fetch', 'es6-promise']
    }
  },
  paths: {
    app: '/mobility_clinic/javascript',
    BVHLoader: '/static/3rdParty/libs/js/three/BVHLoader',
    jquery: '/static/3rdParty/libs/js/jquery/jquery.min',
    d3: '/static/3rdParty/libs/js/d3/d3.min',
    bootstrap: '/static/3rdParty/libs/js/bootstrap/bootstrap.min',
    'bootstrap-dialog': '/static/3rdParty/libs/js/bootstrap3-dialog/bootstrap-dialog',
    'bootstrap-datepicker': '/static/3rdParty/libs/js/eonasdan-bootstrap-datetimepicker/bootstrap-datetimepicker.min',
    'bootstrap-sortable': '/static/3rdParty/libs/js/bootstrap-sortable/bootstrap-sortable',
    'bootstrap-select': '/static/3rdParty/libs/js/bootstrap-select/bootstrap-select.min',
    'bootstrap-slider': '/static/3rdParty/libs/js/seiyria-bootstrap-slider/bootstrap-slider.min',
    'bootstrap-colorpicker': '/static/3rdParty/libs/js/bootstrap-colorpicker/bootstrap-colorpicker.min',
    'bootstrap-typeahead': '/static/3rdParty/libs/js/bootstrap3-typeahead/bootstrap3-typeahead.min',
    'canvas-to-blob': '/static/3rdParty/libs/js/canvas-to-blob/canvas-to-blob.min',
    crossroads: '/static/3rdParty/libs/js/crossroads/crossroads.min',
    'es6-promise': '/static/3rdParty/libs/js/es6-promise/es6-promise.min',
    fetch: '/static/3rdParty/libs/js/fetch/fetch.js',
    hasher: '/static/3rdParty/libs/js/hasher/hasher.min',
    OrbitControls: '/static/3rdParty/libs/js/three/OrbitControls',
    pubsub: '/static/3rdParty/libs/js/pubsub-js/pubsub',
    signals: '/static/3rdParty/libs/js/js-signals/signals.min',
    tinysort: '/static/3rdParty/libs/js/tinysort/tinysort.min',
    three: '/mobility_clinic/javascript/three_wrapper',
    moment: '/static/3rdParty/libs/js/moment/moment-with-locales.min',
    videojs: '/static/3rdParty/libs/js/video.js/video.min'
  },
  deps: ['bootstrap-select', 'bootstrap-slider', 'bootstrap-colorpicker', 'bootstrap-typeahead', 'bootstrap-datepicker', 'app/export_handler', 'bootstrap-sortable', 'OrbitControls', 'BVHLoader', 'app/simulate_drag_and_drop']
});
requirejs(['app/mobility_clinic_main'], function (main) {
  main.startMain();
});
//# sourceMappingURL=main.js.map
