"use strict";

/* Copyright (c) 2013-2019 APDM, Inc
 *
 * mobility_clinic_main.js
 */
define(['jquery', 'd3', 'utils', 'server_handler', 'model_protocol', 'message_dispatcher', 'test_definition_handler', 'app/user_options_handler', 'app/exchange_handler', 'model_dispatcher', 'app/license_handler', 'crossroads', 'hasher', 'res_req_map', 'error_handler', 'metric_definition_helper', 'app/subject_table', 'trial', 'session', 'app/ui_state', 'app/report_enums', 'app/trial_from_recording', 'app/metric_selection_helper', 'app/add_edit_test_condition', 'bootstrap-dialog', 'app/test_sequence_builder', 'app/dialog_in_series', 'app/configuration', 'app/reassign_trial', 'app/add_edit_subject', 'app/run_test', 'app/delete_handler', 'app/report_container', 'app/firmware_check', 'app/upload_handler', 'app/add_edit_study', 'app/login_handler', 'app/user_timeout', 'app/login_menu_handler', 'app/trial_from_logged', 'app/single_user_handler', 'app/tbi_longitudinal_report', 'moment', 'subject'], function ($, d3, utils, ServerHandler, ModelProtocol, MessageDispatcher, TestDefinitionHandler, UserOptionsHandler, ExchangeHandler, ModelDispatcher, LicenseHandler, crossroads, hasher, ResReqMap, ErrorHandler, MetricDefinitionHelper, subjectTable, Trial, Session, uiState, reportEnums, trialFromRecording, MetricSelectionHelper, addEditTestCondition, BootstrapDialog, testSequenceBuilder, DialogInSeries, configuration, reassignTrial, subjectDialog, runTest, deleteHandler, reportContainer, firmwareCheck, UploadHandler, addEditStudy, LoginHandler, Timeout, LoginMenuHandler, trialFromLogged, SingleUserHandler, tbiLongitudinalReport, moment, Subject) {
  /**
   * UploadHander to the global namespace so visible to SWT Browser
   * javascript calls.
   */
  window.UploadHandler = UploadHandler;
  var server = ServerHandler.getInstance(); // Study data

  var currentStudyData; // Current list of studies

  var currentStudyNames = []; // Can user edit the Study e.g. test conditions/test types/test sequences

  var canEditStudy = true; // The currently selected subject.

  var currentSubject; // List of sequence types that have special reports attached to
  // them. Sequences not in this list will be opened as a series report.

  var SPECIAL_REPORT_SEQUENCES = ['CTSIB', 'BESS', 'mBESS', 'Romberg Quotient'];

  function hasSpecialReport(testName) {
    if (SPECIAL_REPORT_SEQUENCES.indexOf(testName) >= 0) {
      return true;
    }

    return false;
  } // Max length for study and user names displayed in the navbar.


  var NAVBAR_NAMES_MAX_CHARS = 14; // Modal dialog for report.

  var reportModal = null; // FIXME: Remove to End on switch to nav left
  // Call handler to update window size

  var winHeight = $(window).height();
  var winWidth = $(window).width();
  $(window).resize(function () {
    winHeight = $(window).height();
    winWidth = $(window).width();
  }); // FIXME: End
  // FIXME: Uncomment to End on switch to nav left
  // Add handler for resizing the side navigation bar.
  // var SIDEBAR_RESIZE_POINT = 1590;
  // var sidebarIsWide = false;
  // if ($(window).width() > SIDEBAR_RESIZE_POINT) {
  //     sidebarIsWide = true;
  //     d3.select('.sidebar')
  //         .style('width', '260px');
  //     d3.select('.sidebar-footer')
  //         .style('left', '210px');
  //     d3.selectAll('.nav-hidden-text')
  //         .style('display', 'inline');
  //     d3.select('#main-content-wrapper')
  //         .style('padding-left', '260px');
  //     d3.select('#min-max-sidenav-button')
  //         .select('span')
  //         .classed('iconic-chevron-right', false)
  //         .classed('iconic-chevron-left', true);
  // }
  // $(window).resize(function() {
  //     var width = $(window).width();
  //     if (width > SIDEBAR_RESIZE_POINT && !sidebarIsWide) {
  //         makeSidebarWide();
  //     } else if (width <= SIDEBAR_RESIZE_POINT && sidebarIsWide) {
  //         makeSidebarNarrow();
  //     } else {
  //         PubSub.publish('window.resized');
  //     }
  // });
  // Setup the handler on the min/max arrow for the sidebar.
  // d3.select('#min-max-sidenav-button')
  //     .on('click', () => {
  //         if (sidebarIsWide) {
  //             makeSidebarNarrow();
  //         } else {
  //             makeSidebarWide();
  //         }
  //     });
  // // Transition for sidebar changes
  // var sidebarTransition = d3.transition()
  //     .duration(150)
  //     .ease(d3.easeLinear);
  // /**
  //  * Widen the navigation sidebar.
  //  */
  // function makeSidebarWide() {
  //     sidebarIsWide = true;
  //     d3.select('.sidebar')
  //         .transition(sidebarTransition)
  //         .style('width', '260px');
  //     d3.select('.sidebar-footer')
  //         .transition(sidebarTransition)
  //         .style('left', '210px');
  //     d3.selectAll('.nav-hidden-text')
  //         .transition()
  //         .delay(155)
  //         .style('display', 'inline');
  //     d3.select('#main-content-wrapper')
  //         .transition(sidebarTransition)
  //         .style('padding-left', '260px')
  //         .on('end', function() {
  //             PubSub.publish('window.resized');
  //         });
  //     d3.select('#min-max-sidenav-button')
  //         .select('span')
  //         .classed('iconic-chevron-right', false)
  //         .classed('iconic-chevron-left', true);
  // }
  // /**
  //  * Narrow the navigation sidebar.
  //  */
  // function makeSidebarNarrow() {
  //     sidebarIsWide = false;
  //     d3.select('.sidebar')
  //         .transition(sidebarTransition)
  //         .style('width', '60px');
  //     d3.select('.sidebar-footer')
  //         .transition(sidebarTransition)
  //         .style('left', '0px');
  //     d3.selectAll('.nav-hidden-text')
  //         .transition(sidebarTransition)
  //         .style('display', 'none');
  //     d3.select('#main-content-wrapper')
  //         .transition(sidebarTransition)
  //         .style('padding-left', '60px')
  //         .on('end', function() {
  //             PubSub.publish('window.resized');
  //         });
  //     d3.select('#min-max-sidenav-button')
  //         .select('span')
  //         .classed('iconic-chevron-right', true)
  //         .classed('iconic-chevron-left', false);
  // }
  // Catch "backspace" key events and disable the only allow
  // if user is editing an input field.

  $(document).on('keydown', function (e) {
    var $target = $(e.target || e.srcElement);

    if (e.keyCode === 8 && !$target.is('input,[contenteditable="true"],textarea')) {
      e.preventDefault();
    }
  }); // Log all user clicks.

  $(window).click(function (d) {
    utils.log('UI click: ' + utils.getXPath(d.target));
  });

  String.prototype.format = String.prototype.f = function () {
    var s = this,
        i = arguments.length;

    while (i--) {
      s = s.replace(new RegExp('\\{' + i + '\\}', 'gm'), arguments[i]);
    }

    return s;
  };
  /**
   * Add a handler on the 'body' to catch modal hide events, and
   * if there is still a modal open, make sure the proper class is
   * set on the body.
   * TODO: This is a bit of a hack. Would be better to switch over to
   * BootstrapDialog which will handle this.
   */


  function addModalHiddenHandler() {
    $('body').on('hidden.bs.modal', function () {
      if ($('.modal.in').length > 0) {
        $(this).addClass('modal-open');
      }
    });
  }
  /**
   * Add a exception handler so they are logged by server.
   */


  function addWindowExceptionHandler() {
    window.onerror = function myErrorHandler(errorMsg, url, lineNumber) {
      var message = "exception occurred:\n\turl:\t{0}\n\tline:\t{1}\n\tmsg:\t{2}\n".format(url, lineNumber, errorMsg); // Console calls cause error in IE 9

      utils.error(message);
      server.post({
        type: 'log_js_exception',
        exception_data: message
      }, null, null, null);
    };
  }
  /**
   * Start the main line of the script.
   */


  function startMain() {
    hasher.setHash('');
    addWindowExceptionHandler();
    addModalHiddenHandler(); // Remove all modal fades if this is IE.

    utils.log('User Agent: ' + window.navigator.userAgent);

    if (utils.isIE()) {
      $('.modal').removeClass('fade');
    }

    server.postUIState(uiState.WAITING_FOR_DOCK);
    setupDispatcher();
    loadInitDialog();
  }
  /**
   * Load the "Initializing" floating window and wait for server to finish loading
   * its data. Also set up launch page. Once initialization is done, ask if this
   * is a streaming record or not.
   */


  function loadInitDialog() {
    $('#switchable').load('/mobility_clinic/html/initializing.html', pageLoaded);

    function pageLoaded() {
      var spinner = getWaitSpinner('canvasloader-container');
      loadExchangeStatus(spinner);
    }
  }
  /**
   * Check the Mobility Exchange status. Force the login dialog
   * and don't bother loading any properties/study data until
   * login state is resolved.
   * @param spinner The spinner to kill when properties are loaded.
   */


  function loadExchangeStatus(spinner) {
    var exchangeStatus = crossroads.addRoute('exchangeStatusLoaded', function () {
      crossroads.removeRoute(exchangeStatus);
      var exHandler = ExchangeHandler.getInstance();

      if (server.hasJsPostHandler() && !exHandler.loggedIn()) {
        exHandler.webLogin();
        return;
      } else if (exHandler.associatedWithServer() && !exHandler.loggedIn()) {
        exHandler.login();
        var loggedInRoute = crossroads.addRoute('loggedIntoExchange', function () {
          crossroads.removeRoute(loggedInRoute);
          loadProperties(spinner);
        });
        return;
      }

      loadProperties(spinner);
    }); // Initialize the ExchangeHandler instance and get the current
    // state.

    ExchangeHandler.getInstance();
  }
  /**
   * Load the properties that we care about. Move on to
   * loading initial data when done.
   * @param spinner The spinner to kill when properties are loaded.
   */


  function loadProperties(spinner) {
    var lastStudyRoute = crossroads.addRoute('mobilitylabPropertiesLoaded', function () {
      crossroads.removeRoute(lastStudyRoute);
      spinner.kill();
      doFirmwareCheck();
      loadLicenseData();
    });
    UserOptionsHandler.getInstance().getRequiredMobilityLabProperties();
  }
  /**
   * Check the firmware of any connected hardware and the SD card if
   * this is an RCP instance.
   */


  function doFirmwareCheck() {
    if (!server.hasJsPostHandler()) {
      server.post({
        type: ModelProtocol.is_configured
      }, 'json', function (d) {
        if (d.currentHardware === 'V2' && d.firmwareChecked === false) {
          firmwareCheck.checkFirmware(true, true);
        }
      }, function (d) {
        ErrorHandler.showError(d.error().statusText);
      });
    }
  }
  /**
   * Load the license data for this instance and move on.
   */


  function loadLicenseData() {
    if (server.hasJsPostHandler()) {
      loadMetricDefinitions();
    } else {
      var licenseLoaded = crossroads.addRoute('licenseDataUpdated', function () {
        crossroads.removeRoute(licenseLoaded);

        if (!LicenseHandler.getInstance().isResearchView()) {
          $('#export-study').remove();
        }

        loadMetricDefinitions();
      });
      LicenseHandler.getInstance();
    } // Initialize the model dispatcher here as well.


    ModelDispatcher.getInstance();
  }
  /**
   * Load metric definitions from the server.
   */


  function loadMetricDefinitions() {
    // Metric definitions loaded.
    var defsLoaded = crossroads.addRoute('metricDefinitionsLoaded', function () {
      crossroads.removeRoute(defsLoaded);
      loadStudyNames();
    });
    MetricDefinitionHelper.getInstance();
  }

  function loadStudyNames() {
    var studyName = UserOptionsHandler.getInstance().getCurrentStudyName(); // Get the list of study names to see what study (if any) can
    // be loaded.

    var studyNamesRoute = crossroads.addRoute('study_list_loaded/{key}', function (key) {
      crossroads.removeRoute(studyNamesRoute); // Update the study selection dialog when study list is loaded.

      crossroads.addRoute('study_list_loaded/{key}', function (key) {
        var studyList = ResReqMap.getInstance().getResponseData(key);
        updateStudyDropdown(studyList);
      }, 0);
      var studyNames = ResReqMap.getInstance().getResponseData(key);

      if (!studyNames.length) {
        noAvailableStudies();
      } else {
        if (studyNames.indexOf(studyName) === -1) {
          studyName = studyNames[0];
          UserOptionsHandler.getInstance().setCurrentStudyName(studyName);
        }

        key = ResReqMap.getInstance().setRequestData(studyName);
        crossroads.parse('dispatch/requestStudy/' + key);
      }
    }, 5); // Set the priority to be higher than nested route

    crossroads.parse('dispatch/requestStudyNames');
    var studyLoadedRoute = crossroads.addRoute('study_loaded', function () {
      crossroads.removeRoute(studyLoadedRoute);
      SingleUserHandler.getInstance().studyUpdated();
      initialDataLoaded();
    });
  }
  /**
   * Initial data loaded, and necessary singleton classes initialized.
   */


  function initialDataLoaded() {
    currentStudyData = ModelDispatcher.getInstance().getCurrentStudy();
    UserOptionsHandler.getInstance().registerStudyProperties(currentStudyData.getProperties());
    TestDefinitionHandler.getInstance();
    LoginMenuHandler.getInstance();
    MetricDefinitionHelper.getInstance().currentSelectionGroup('default');
    $(document).trigger('initComplete', []);
    crossroads.addRoute('', loadLaunchPage); // Do a lightweight login if there are HttpBackupSettings.

    if (UserOptionsHandler.getInstance().getRequireLightweightLogin() === true) {
      LoginHandler.getInstance().login(ModelDispatcher.getInstance().getCurrentStudy());
    } // Update the study dropdown


    crossroads.parse('dispatch/requestStudyNames'); // Add a route for reloading the study data, if it changes.

    crossroads.addRoute('study_loaded', reloadStudyData); // Start up the inactivity timeout.

    Timeout.getInstance(); // Check the browser and version.

    checkBrowserVersion(); // Setup the initial view.

    initSidePanel();
    loadLaunchPage();
  }
  /**
   * Handle case where there are no studies currently available.
   */


  function noAvailableStudies() {
    if (!server.hasJsPostHandler()) {
      var exchange = ExchangeHandler.getInstance();

      if (exchange.updateHost().indexOf('mobilityexchange') > -1) {
        // The update site points to a mobility_exchange instance
        if (!exchange.associatedWithServer()) {
          // the user has not logged in yet for the first time,
          // so display the MX connection dialog
          exchange.setupNewServerConnection();
          return;
        } else {
          // The user has previously logged in, so present the MX login dialog
          exchange.login();
          return;
        }
      } // We have a server but are not logged in.


      if (exchange.associatedWithServer() && !exchange.loggedIn()) {
        exchange.login();
        return;
      } else if (exchange.associatedWithStudy()) {
        addEditStudy.add([]);
      }
    }
  }
  /**
   * Reload the study data.
   */


  function reloadStudyData() {
    currentStudyData = ModelDispatcher.getInstance().getCurrentStudy();
    var userOpts = UserOptionsHandler.getInstance();
    userOpts.setCurrentStudyName(currentStudyData.getStudyName());
    userOpts.registerStudyProperties(currentStudyData.getProperties()); // Update the test definitions

    TestDefinitionHandler.getInstance().updateDefinitions();
    MetricDefinitionHelper.getInstance().currentSelectionGroup('default');
    MetricDefinitionHelper.getInstance().selectedMetricGroups(userOpts.getMetricSelectionGroups());
    SingleUserHandler.getInstance().studyUpdated(); // Set the hash without triggering handler

    hasher.changed.active = false;
    hasher.setHash('');
    hasher.changed.active = true;
    loadLaunchPage(); // Get the updated study list

    crossroads.parse('dispatch/requestStudyNames');
    LoginMenuHandler.getInstance();
  }
  /**
   * Setup the dispatcher to handle the routing for different page content.
   */


  function setupDispatcher() {
    // Make sure we're typecasting arguments.
    crossroads.shouldTypecast = true; // Add path for VIEW and ERROR handlers

    crossroads.addRoute('message/VIEW/{key}', handleViewMessage);
    crossroads.addRoute('message/ERROR/{key}', handleErrorMessage); // Refresh the subject page when trial added

    crossroads.addRoute('message/SUBJECT/{key}', function (key) {
      var subjectJson = ResReqMap.getInstance().getResponseData(key);
      var subject = new Subject(subjectJson);
      var idObj = subject.getObjId();
      hasher.setHash('');
      crossroads.parse('dispatch/subject?id=' + idObj.getId() + '&localId=' + idObj.getLocalId());
    }); // Refresh the study when we go back to subjects page.

    crossroads.addRoute('subjects/', function () {
      crossroads.parse('dispatch/refreshStudy');
    });
    crossroads.addRoute('study_refreshed', function () {
      hasher.setHash('subject');
      loadLaunchPage(); // If a report is open, close it.

      if (reportModal) {
        reportModal.hide(true);
      }
    });
    crossroads.addRoute('options/', loadOptionsPage); // Use the old configuration path if the user
    // is using V1 hardware

    crossroads.addRoute('hw_configure/', function () {
      if (LicenseHandler.getInstance().isKinematics()) {
        configuration.open(false, false);
      } else {
        server.post({
          type: ModelProtocol.is_configured
        }, 'json', function (d) {
          if (d.currentHardware === 'V2') {
            configuration.open(false, true);
          } else {
            server.post({
              type: ModelProtocol.configure_monitors
            }, null, null, null);
          }
        });
      }
    });
    crossroads.addRoute('hw_poweroff/', function () {
      server.post({
        type: ModelProtocol.power_off_monitors
      }, null, null, null);
    });
    crossroads.addRoute('configVideo/', function () {
      server.post({
        type: ModelProtocol.manage_cameras
      }, null, null, null);
    }); // Add or edit a study.

    crossroads.addRoute('add_edit_study/{type}', function (type) {
      if (type === 'edit') {
        addEditStudy.edit(currentStudyNames);
      } else {
        addEditStudy.add(currentStudyNames);
      }
    }); // Study deleted. Load another study.

    crossroads.addRoute('deletedStudy/{key}', function (key) {
      var studyList = ResReqMap.getInstance().getResponseData(key);

      if (!studyList.length) {
        addEditStudy.add(studyList);
        return;
      }

      var reqKey = ResReqMap.getInstance().setRequestData(studyList[0]);
      crossroads.parse('dispatch/requestStudy/' + reqKey);
    }); // Subject selected from subject list.

    crossroads.addRoute('subject{?ids}', function () {
      loadSubjectsPage();
    }); // Handle returns from the test selection builder.

    crossroads.addRoute('tests_selected/{key}', function (key) {
      var jsObj = ResReqMap.getInstance().getResponseData(key);
      runTest.beginTest(jsObj, currentSubject);
    });
    crossroads.addRoute('completing_sequence/{key}', function (key) {
      var allTests = ResReqMap.getInstance().getResponseData(key); // Get the trials for the rest of the sequence.

      allTests.completedTests = allTests.session.getAllTrials();
      runTest.beginTest(allTests, currentSubject, true);
    }); // Test, or test series, completed.

    crossroads.addRoute('testCompleted/{key}{?query}', function (key) {
      var allTests = ResReqMap.getInstance().getResponseData(key);
      loadSubjectsPage();
      testCompleted(allTests);
    }); // Subject added to study.

    crossroads.addRoute('addedSubject', loadLaunchPage); // Subject in study edited.

    crossroads.addRoute('editedSubject{?query}', function () {
      loadSubjectsPage();
    }); // Deleted subject from study.

    crossroads.addRoute('deletedSubject', function () {
      currentSubject = null;
      loadLaunchPage();
    }); // Refresh the condition tabs

    crossroads.addRoute('updateTestConditionTabs{?query}', function (query) {
      currentStudyData = ModelDispatcher.getInstance().getCurrentStudy();

      if (query.id && query.id !== '') {
        $('#' + query.id).empty();
        buildSingleTestConditionTab(query.id, {
          name: query.testName
        });
      } else {
        buildTestConditionTabs(query.testName);
        MetricSelectionHelper.getInstance().buildMetricTabs('#configure-metrics');
      }
    }); // Make sure we handle hash changes, even if they are the same as
    // the previous hash.

    crossroads.ignoreState = true; // Setup logging for hash changes

    crossroads.routed.add(function (request) {
      utils.log('Current hash: ' + request);
    }); // Setup the handler for changes to the hash.

    function parseHash(newHash) {
      crossroads.parse(newHash);
    }

    hasher.initialized.add(parseHash);
    hasher.changed.add(parseHash);
    hasher.init(); // Start message dispatcher

    MessageDispatcher.getInstance();
  }
  /**
   * Handler messages that effect the application globally.
   * @param {Number} key Key into the ResReqMap for message data.
   */


  function handleViewMessage(key) {
    var message = ResReqMap.getInstance().getResponseData(key);

    if (message === 'RESET_VIEW') {
      // Reset the view by reloading the launch page. Also
      // destroys singleton instances that need to reload their
      // data from the server.
      MetricDefinitionHelper.getInstance().destroy();
      LicenseHandler.getInstance().destroy();
      ExchangeHandler.getInstance().destroy();
      UserOptionsHandler.getInstance().destroy(); // Close the study add dialog. Could be open if user is
      // connecting to MX for the first time.

      addEditStudy.forceCloseDialog();
      loadInitDialog();
    }
  }
  /**
   * Handler error messages that effect the application
   * globally (e.g. DomainTransform issues, db corruption)
   * @param {Number} key Key into the ResReqMap for message data.
   */


  function handleErrorMessage(key) {
    var errorMsg = ResReqMap.getInstance().getResponseData(key);

    if (errorMsg === 'DomainTransformRequestException') {
      new ErrorHandler().showTransformError();
    }
  }
  /**
   * Set up handlers for the top level navigation buttons and
   * the options under the "Study" dropdown.
   */


  function initSidePanel() {
    var allSideBtns = $('.top-nav li');
    $('#patients-button a').click(function () {
      allSideBtns.removeClass('active');
      $(this).parent().addClass('active');
    });
    $('#configure-button a').click(function () {
      allSideBtns.removeClass('active');
      $(this).parent().addClass('active');
    });
    $('#options-button a').click(function () {
      allSideBtns.removeClass('active');
      $(this).parent().addClass('active');
    }); // Hide hardware buttons if this is a MobilityLab.web instance.

    if (server.hasJsPostHandler()) {
      ExchangeHandler.getInstance();
      $('.rcp-only').css('display', 'none');
    } else {
      $('#hw-poweroff-button a').click(function () {
        crossroads.parse('hw_poweroff');
      }); // Video configuration

      $('#config-video-button a').click(function () {
        crossroads.parse('configVideo');
      });
    } // Study add handler


    ModelDispatcher.getInstance().checkCreatePermission('Study', 'null', currentStudyData.getObjId()).then(function (d) {
      if (d.hasPermission) {
        $('#add-study a').click(function () {
          crossroads.parse('add_edit_study/add');
        });
      } else {
        $('#add-study a').css({
          'color': '#9d9d9d',
          'cursor': 'not-allowed'
        });
      }
    }, function (e) {
      ErrorHandler.showError(e.error().statusText);
    });
    $('#export-study a').off('click').click(function () {
      var key = ResReqMap.getInstance().setRequestData(currentStudyData.getObjId());
      crossroads.parse('dispatch/exportToCsv/study/' + key);
    }); // Software update button handler

    setupUpdateButton();
  }
  /**
   * If update available, make button visible, add handler
   * and create a pop-up for the button.
   */


  function setupUpdateButton() {
    if (server.hasJsPostHandler() || !LicenseHandler.getInstance().isUpdateAvailable()) {
      return;
    }

    $('#software-update-button').css('display', 'block');
    $('#software-update-button a').click(function () {
      LicenseHandler.getInstance().updateApplication();
    });
    $('#software-update-button').popover({
      placement: 'bottom',
      trigger: 'hover',
      html: true,
      title: 'Software Update Available',
      content: 'There is a software update available. Please click on ' + 'the <span class="text-warning iconic iconic-flash"></span> ' + 'button to start the update process.',
      // container: 'body',
      delay: {
        'show': 500,
        'hide': 100
      }
    });
    $('#software-update-button').popover('show');
    $(document).on('click.updatePopover', function () {
      $('#software-update-button').popover('hide');
      $(document).off('click.updatePopover');
    });
  }
  /**
   * Check the browser version, and if less than IE 10 show a warning.
   */


  function checkBrowserVersion() {
    var ieVersion = utils.isIE();

    if (ieVersion && ieVersion < 11) {
      ErrorHandler.showError('You are running Internet Explorer Version ' + ieVersion + '. ' + 'Mobility Lab is designed to run on version ' + '11 or greater. ' + 'Some functionality may not be available.');
    }
  }
  /**
   * Update the study list dropdown.
   * @param {Array} studyList List of study names.
   */


  function updateStudyDropdown(studyList) {
    // Set the current study names
    currentStudyNames = studyList;
    var dropdown = d3.select('.study-dropdown');
    var currentName = studyList[0];

    if (currentStudyData) {
      currentName = currentStudyData.getStudyName();
    }

    var displayName = utils.getTruncatedDisplayString(currentName, NAVBAR_NAMES_MAX_CHARS);
    dropdown.select('#study-dropdown-current').text(displayName);
    dropdown.selectAll('.study-dropdown-entry').remove(); // Add all studies, except current, into dropdown

    var selections = dropdown.select('#study-dropdown-selections');
    studyList.forEach(function (study) {
      var link = selections.insert('li', '.divider').attr('class', 'study-dropdown-entry link').append('a');

      if (study === currentName) {
        link.html(study + '<span class="iconic iconic-check"></span>');
      } else {
        link.text(study);
      }

      link.on('click', function () {
        var studyName = d3.select(this).text();
        UserOptionsHandler.getInstance().setCurrentStudyName(studyName);
        crossroads.parse('dispatch/requestStudy/' + ResReqMap.getInstance().setRequestData(studyName));
      });
    });
  }
  /**
   * Load the options page.
   */


  function loadOptionsPage() {
    // Make sure the test definitions are all up to date.
    TestDefinitionHandler.getInstance().updateDefinitions();
    $('#switchable').load('/mobility_clinic/html/options.html', pageLoaded);

    function pageLoaded() {
      // Remove fade if this is IE
      if (utils.isIE()) {
        $('.modal').removeClass('fade');
      } // Set study name on header


      var studyName = UserOptionsHandler.getInstance().getCurrentStudyName();
      $('#options-study-name').text(studyName); // Subject options tab

      buildSubjectOptionsTab(); // Create tabs for the metric configuration

      MetricSelectionHelper.getInstance().buildMetricTabs('#configure-metrics');
      buildTestConditionTabs();
      buildCustomSequenceTable('#custom-sequence-table');
      $('#options-tabs-list a:first').tab('show'); // Add the "save" handler to all the checkboxes

      $('#subject-options input:checkbox').click(function () {
        saveOptions();
      });
      $('#metric-group-delete').click(function () {
        MetricSelectionHelper.getInstance().deleteMetricGroup('#configure-metrics');
      }); // Remove items not useable in Mobility Web

      if (server.hasJsPostHandler()) {
        $('.rcp-only').remove();
      }
    }
  }
  /**
   * Set and manage the checkboxes for the subject options. Require
   * that either the public id or name is always required and
   * displayed.
   */


  function buildSubjectOptionsTab() {
    var subjectOptionsDiv = d3.select('#subject-options');
    var options = UserOptionsHandler.getInstance();

    for (var prop in options.getPatientRequiredFields()) {
      if (options.getPatientRequiredFields()[prop] === true) {
        subjectOptionsDiv.select('#required-' + prop).attr('checked', 'checked');
      }
    } // Require that either the public id or name are selected.


    ['required-'].forEach(function (d) {
      var id = subjectOptionsDiv.select('#' + d + 'id');
      var name = subjectOptionsDiv.select('#' + d + 'name');
      id.on('click', function () {
        if (id.property('checked') === false && name.property('checked') === false) {
          name.property('checked', true);
        }
      });
      name.on('click', function () {
        if (id.property('checked') === false && name.property('checked') === false) {
          id.property('checked', true);
        }
      });
    }); // Make sure that the enabling month requires year, and day
    // requires month.

    var birthYear = subjectOptionsDiv.select('#required-birthYear');
    var birthMonth = subjectOptionsDiv.select('#required-birthMonth');
    var birthDay = subjectOptionsDiv.select('#required-birthDay');
    birthYear.on('click', function () {
      if (birthYear.property('checked') === false) {
        birthMonth.property('checked', false);
        birthDay.property('checked', false);
      }
    });
    birthMonth.on('click', function () {
      if (birthMonth.property('checked') === false) {
        birthDay.property('checked', false);
      } else {
        birthYear.property('checked', true);
      }
    });
    birthDay.on('click', function () {
      if (birthDay.property('checked') === true) {
        birthMonth.property('checked', true);
        birthYear.property('checked', true);
      }
    }); // Annotations enabled checkbox

    if (options.getAnnotationsEnabled() === true) {
      subjectOptionsDiv.select('#enable-annotations').attr('checked', 'checked');
    } // Default report type


    var setTable = options.getDefaultReportTable();
    var tableDropdown = $('#default-report-table-dropdown');

    if (!canEditStudy) {
      tableDropdown.attr('disabled', 'disabled');
    }

    if (setTable && setTable !== '') {
      tableDropdown.val(setTable);
    }

    tableDropdown.selectpicker({
      width: 'auto'
    });
    tableDropdown.off('change').change(function () {
      options.setDefaultReportTable(parseInt($(this).val(), 10));
      tableDropdown.selectpicker('refresh');
    }); // Disable delete when running tests.

    if (options.getDisableDeleteAfterRun() === true) {
      subjectOptionsDiv.select('#disable-testdelete').attr('checked', 'checked');
    } // Allow/disallow selecting "Logging" as in option on
    // configuration page.


    if (options.getAllowLoggingConfiguration() === true) {
      subjectOptionsDiv.select('#allow-logging-configuration').attr('checked', 'checked');
    }
  }
  /**
   * Save the subject options set on "Subject Options" tab.
   */


  function saveOptions() {
    // TODO: Think about unifying metric selections and user options.
    var options = {};
    $('.subject_options_form :input').each(function () {
      var valueSplit = this.id.split('-');

      if (!options[valueSplit[0]]) {
        options[valueSplit[0]] = {};
      }

      options[valueSplit[0]][valueSplit[1]] = $(this).is(':checked');
    });
    var optHandler = UserOptionsHandler.getInstance();
    optHandler.setPatientRequiredFields(options.required);
    optHandler.setAnnotationsEnabled(options.enable.annotations);
    optHandler.setDisableDeleteAfterRun(options.disable.testdelete);
    optHandler.setAllowLoggingConfiguration(options.allow.logging);
  }
  /**
   * Set up the handlers for the launch page. and definitions for
   * the supported test types are loaded.
   */


  function loadLaunchPage() {
    $('#switchable').load('/mobility_clinic/html/launch.html', pageLoaded);
    currentStudyData = ModelDispatcher.getInstance().getCurrentStudy();
    MetricDefinitionHelper.getInstance().selectedMetricGroups(UserOptionsHandler.getInstance().getMetricSelectionGroups()); // Bypass the building of the subject table if this is a single user UI
    // instance.

    if (SingleUserHandler.getInstance().isSingleUserUI()) {
      setupSingleUserUI();
      return;
    } // Check if user is able to edit the Study.


    ModelDispatcher.getInstance().checkPermissions('edit', currentStudyData.getObjId()).then(function (d) {
      canEditStudy = d.hasPermission;

      if (d.hasPermission) {
        $('#edit-delete-study a').off('click').click(function () {
          crossroads.parse('add_edit_study/edit');
        }).css({
          'color': '',
          'cursor': ''
        });
      } else {
        $('#edit-delete-study a').off('click').css({
          'color': '#9d9d9d',
          'cursor': 'not-allowed'
        });
      }
    }, function (e) {
      ErrorHandler.showError(e.error().statusText);
    });

    function pageLoaded() {
      ModelDispatcher.getInstance().checkCreatePermission('StudySubject', 'Study', currentStudyData.getObjId()).then(function (d) {
        if (d.hasPermission) {
          $('#add-subject').click(function () {
            subjectDialog.add();
          });
        } else {
          $('#add-subject').attr('disabled', 'disabled');
        }
      }, function (e) {
        ErrorHandler.showError(e.error().statusText);
      }); // Create the table of subjects

      buildSubjectsTable(d3.select('#subject-select-table'));
    }
  }
  /**
   * Setup the UI for a single user, who is also the only subject.
   * Have to assume that the only subject in the study is the single
   * user.
   */


  function setupSingleUserUI() {
    $('.single-user-hide').css('display', 'none');
    var subject = currentStudyData.getAllSubjects()[0];
    var objId = subject.getObjId();
    crossroads.parse('dispatch/subject?id=' + objId.getId() + '&localId=' + objId.getLocalId());
    $('#single-subject-button').css('display', 'block').addClass('active');
    $('#single-subject-button').find('div', 'block').text(UserOptionsHandler.getInstance().getSubjectName(subject));
    $('#single-subject-button').click(function () {
      crossroads.parse('dispatch/subject?id=' + objId.getId() + '&localId=' + objId.getLocalId());
      $('.nav-button-left').removeClass('active');
      $(this).addClass('active');
    });
  }
  /**
   * Display all tests for the currently selected subject.
   * @param {Object} ids The object containing the ids of the
   * subject to display.
   */


  function loadSubjectsPage() {
    currentSubject = ModelDispatcher.getInstance().getCurrentSubject();
    $('#switchable').load('/mobility_clinic/html/subjects.html', pageLoaded);
    server.postUIState(uiState.READING_RESULTS);

    function pageLoaded() {
      // Remove buttons if this is single user/subject UI
      if (SingleUserHandler.getInstance().isSingleUserUI()) {
        $('.single-user-hide').css('display', 'none');
      }

      $('#edit-subject-button').click(function () {
        subjectDialog.edit(currentSubject);
      });
      ModelDispatcher.getInstance().checkPermissions('delete', currentSubject.getObjId()).then(function (d) {
        if (d.hasPermission) {
          $('#delete-subject-button').click(function () {
            deleteHandler.deleteSubject(currentSubject, UserOptionsHandler.getInstance().getSubjectName(currentSubject));
          });
        } else {
          $('#delete-subject-button').attr('disabled', 'disabled');
        }
      }, function (e) {
        ErrorHandler.showError(e.error().statusText);
      });

      if (LicenseHandler.getInstance().isResearchView()) {
        $('#export-subject-button').click(function () {
          var key = ResReqMap.getInstance().setRequestData(currentSubject.getObjId());
          crossroads.parse('dispatch/exportToCsv/subject/' + key);
        });
      } else {
        $('#export-subject-menu-item').remove();
      }

      $('#trial-from-file-button').click(function () {
        trialFromRecording.open(currentSubject);
      }); // Only display the trial from logged recording on
      // Opals if user has the "allowLogging" flag set to true.

      if (UserOptionsHandler.getInstance().getAllowLoggingConfiguration()) {
        $('#trial-from-logged-import').click(function () {
          crossroads.parse('dispatch/importLogged'); // trialFromLogged.open(currentSubject);
        });
      } else {
        $('#trial-from-logged-import-list-item').css('display', 'none');
      }

      d3.select('#subject-header-title').text(function () {
        return UserOptionsHandler.getInstance().getSubjectName(currentSubject);
      });
      buildTrialCells(currentStudyData, d3.select('#subject-test-cells-container')); // Disable the button if permissions do not
      // allow creating new tests.

      ModelDispatcher.getInstance().checkCreatePermission('Trial', 'StudySubject', currentSubject.getObjId()).then(function (d) {
        var newTestBtn = d3.selectAll('#new-test-button');

        if (d.hasPermission) {
          newTestBtn.on('click', function () {
            checkConfiguration(function () {
              testSequenceBuilder.open(null);
            });
          });
        } else {
          newTestBtn.attr('disabled', 'disabled');
          $('#trial-from-file-button').css({
            'color': '#9d9d9d',
            'cursor': 'not-allowed',
            'pointer-events': 'none'
          });
        }
      }, function (e) {
        ErrorHandler.showError(e.error().statusText);
      }); // Remove Mobility Lab

      if (server.hasJsPostHandler()) {
        $('.rcp-only').css('display', 'none');
      } // If we have TBI trials, enable the "TBI Longitudinal" button


      var tbiTrials = currentSubject.getAllTrials().filter(function (d) {
        return utils.isTBITrial(d);
      });

      if (!SingleUserHandler.getInstance().isSingleUserUI() && tbiTrials && tbiTrials.length) {
        $('#tbi-report-button').css('display', 'inline-block').click(function () {
          tbiLongitudinalReport.open(currentSubject);
        });
      } else {
        $('#tbi-report-button').css('display', 'none').off('click');
      }
    }
  }
  /**
   * Check the configuration flag on server, and if there is no vaild
   * configuration display a warning, otherwise continue to the test
   * sequence builder dialog.
   * @param {Function} nextCall The function to call if the configuration
   * check succeeds.
   */


  function checkConfiguration(nextCall) {
    if (server.hasJsPostHandler()) {
      nextCall();
      return;
    }

    server.post({
      type: ModelProtocol.is_configured
    }, 'json', function (d) {
      if (d.isConfigured === true && d.currentHardware !== 'MIXED' && d.currentHardware === d.previousHardware) {
        nextCall();
        return;
      }

      openNotReadyToRecord(d);
    }, function (d) {
      ErrorHandler.showError(d.error().statusText);
    });
  }
  /**
   * Open dialog informing user of issue with current configuration status.
   * @param {Object} configState The configuration state.
   */


  function openNotReadyToRecord(configState) {
    var msg = '<p>Your system must be configured for ' + 'recording before you can record any trials.<\p>';

    if (configState.currentHardware === 'MIXED') {
      msg = '<p>A mixture of both V1 and V2 has been detected. ' + 'The system can only support one hardware type. ' + 'Please select one set of hardware and power off ' + 'and disconnect the other. You must then configure the ' + 'hardware before recording.</p>';
    } else {
      msg = '<p>You must configure your hardware before recording.</p>';
    }

    msg = msg + '<p>Press the "Continue" button to open the ' + 'configuration dialog</p>';
    var dialog = new ErrorHandler({
      title: 'Not Ready to Record',
      message: msg,
      type: '',
      // Leave this blank
      buttonIcon: 'iconic-caret-right',
      buttonText: 'Continue',
      closeCall: function closeCall() {
        crossroads.parse('hw_configure');
      }
    });
    dialog.show();
  }
  /**
   * Display the recently completed test, or test series report
   * dialog if there are completed trials. Don't display anything
   * if this is a single user UI
   * @param {Object} allTests Object containing completed and pending trials.
   */


  function testCompleted(allTests) {
    if (SingleUserHandler.getInstance().isSingleUserUI()) {
      return;
    }

    currentSubject = ModelDispatcher.getInstance().getCurrentSubject();

    if (allTests.completedTests.length) {
      var trial = currentSubject.getMostRecentTrial();

      if (hasSpecialReport(allTests.session.getTestName())) {
        reportContainer.singleTrialReport(currentSubject, trial.sequence, false);
        return;
      }

      if (allTests.completedTests.length > 1) {
        reportContainer.multipleTrialReport(currentSubject, allTests.completedTests, reportEnums.filterType.DAY, false);
      } else {
        reportContainer.singleTrialReport(currentSubject, trial, false);
      }
    }
  }
  /**
   * Build a series of cells for each day and the trials run during that day.
   * If this is a single user UI, then only provide a big "New Test" button.
   * @param studyData The study data.
   * @param element The selection to build cells inside.
   */


  function buildTrialCells(studyData, element) {
    if (SingleUserHandler.getInstance().isSingleUserUI()) {
      element.append('div').style('text-align', 'center').html('<a href="#/test_sequence_builder/admin?onlyTests=false" ' + 'id="new-test-button" class="btn btn-lg btn-primary">' + '<span class="iconic iconic-caret-right" ' + 'title="run test" aria-hidden="true">' + '</span>New Exercise</a>'); // Leaving the above button in place as an emergency backup,
      // but ideally the "Test Sequence" selection dialog should appear,
      // since we are only allowing the ability to run tests from
      // within this UI.

      checkConfiguration(function () {
        hasher.setHash('#/test_sequence_builder/admin?onlyTests=false');
        testSequenceBuilder.open(null);
      });
      return;
    }

    var trialsByDay = currentSubject.groupTrialsAndSequencesByDay();
    var dayKeys = Object.keys(trialsByDay);

    if (dayKeys.length < 1) {
      element.append('h3').text('No trials for subject.');
      return;
    }

    dayKeys.sort(function (a, b) {
      return d3.ascending(a, b);
    }); // Put trialsByDay into a matrix with max four trials per row.

    var trialsDayMatrix = [];
    var k = 0;

    for (var i = 0; dayKeys.length > i; i++) {
      if (i !== 0 && i % 4 === 0) {
        k++;
      }

      if (trialsDayMatrix[k] === undefined) {
        trialsDayMatrix[k] = [];
      }

      trialsDayMatrix[k][i % 4] = trialsByDay[dayKeys[i]];
    } // Build the rows for the visit cells.


    var container = element.append('div').attr('class', 'container-fluid');
    var dayRows = container.selectAll('.row').data(trialsDayMatrix).enter().append('div').attr('class', 'row');
    var dayDiv = dayRows.selectAll('.trial_day_cell').data(function (d) {
      return d;
    }).enter().append('div').attr('class', 'col-sm-6 col-md-6 col-lg-3').append('div').attr('class', 'trial_day_cell');
    dayDiv.append('span').attr('class', 'trial_day_cell_date').text(function (d) {
      return d.day.format('MMMM D, YYYY');
    }).on('click', function (d) {
      // Flatten out the trials from within any sequences
      var flattened = [];
      d.trials.forEach(function (e) {
        if (e instanceof Session) {
          flattened = flattened.concat(e.getAllTrials());
        } else {
          flattened.push(e);
        }
      });
      reportContainer.multipleTrialReport(currentSubject, flattened, reportEnums.filterType.DAY, true);
    });
    dayDiv.append('ul').selectAll('ul').data(function (d) {
      return d.trials;
    }).enter().append('li').attr('class', 'link').each(function (d) {
      var item = d3.select(this);

      if (d instanceof Trial) {
        makeTrialEntryForCell(d, item);
      } else {
        makeSequenceEntryForCell(d, item);
      }
    }); // If this is a single user UI instance, remove all the
    // click handlers and the link class

    if (SingleUserHandler.getInstance().isSingleUserUI()) {
      element.selectAll('span').on('click', null);
      element.selectAll('.link').classed('link', false);
      element.selectAll('.trial_day_cell_date').style('cursor', 'auto');
    }
  }
  /**
   * Make the entry in the cell for a single trial.
   * @param {Trial} trial The trial for the entry.
   * @param {d3.selection} item The element to add entry to.
   */


  function makeTrialEntryForCell(trial, item) {
    item.append('span').attr('class', 'bold').text(function (d) {
      return d.getTestDisplayName();
    });
    item.append('span').text(function (d) {
      return ', ' + d.getConditionDisplayName() + ' - ' + d.getTime();
    });
    item.on('click', function (d) {
      reportContainer.singleTrialReport(currentSubject, d, true);
    });
  }
  /**
   * Make the entry in the cell for a sequence. Adds caret to
   * show/hide the list of trials in the sequence.
   * @param {Session} sequence The sequence for the entry.
   * @param {d3.selection} item The element to add the sequence entry to.
   */


  function makeSequenceEntryForCell(sequence, item) {
    var sequenceTitle = item.append('span');
    sequenceTitle.append('span').attr('class', 'bold').text(function (d) {
      return d.getTestName();
    });
    sequenceTitle.append('span').text(function (d) {
      return ' - ' + d.getTime();
    });
    item.select('span').on('click', function (d) {
      // If not a special report, open as series.
      if (hasSpecialReport(d.getTestName())) {
        reportContainer.singleTrialReport(currentSubject, d, true);
        return;
      }

      reportContainer.multipleTrialReport(currentSubject, d.getAllTrials(), reportEnums.filterType.SEQUENCE, true);
    });
    var btn = item.append('span').attr('class', 'sequence-expand-btn iconic iconic-caret-bottom');
    var trialList = item.append('ul').attr('class', 'trial-day-cell-sequence-list');
    trialList.selectAll('li').data(sequence.getAllTrials()).enter().append('li').attr('class', 'link').text(function (d) {
      return d.getTestDisplayName() + ', ' + d.getConditionDisplayName() + ' - ' + d.getTime();
    }).on('click', function (d) {
      reportContainer.singleTrialReport(currentSubject, d, true);
    });
    var list = $(trialList.node());
    btn.on('click', function () {
      list.slideToggle();
    });
    list.slideUp(); // Detemine if we have a recent incomplete sequence.

    if (moment().diff(sequence.getDateObj(), 'hours') < 24) {
      if (!findIncompleteSequences(trialList, sequence)) {
        list.slideUp();
      }
    }
  }
  /**
   * Check to see if a sequence is incomplete, and determine what
   * trials have not been completed. Add UI elements to allow
   * completing the sequence.
   * @param {d3.selection} trialList The list of completed trials.
   * @param {Session} sequence The sequence to check.
   * @return {Boolean} True is sequence is incomplete.
   */


  function findIncompleteSequences(trialList, sequence) {
    var i;
    var allTests = {
      pendingTests: [],
      completedTests: [],
      session: sequence
    };
    var seqDef = TestDefinitionHandler.getInstance().getSequenceDefinition(sequence.getTestName());

    if (!seqDef) {
      return false;
    }

    var completedTrials = sequence.getAllTrials().map(function (d) {
      return {
        testName: d.getTestName(),
        conditionName: d.getConditionName(),
        sequence: sequence
      };
    });
    var sequenceTests = seqDef.testNames.split('::');
    var sequenceConditions = seqDef.testConditions.split('::');
    completedTrials.forEach(function (d) {
      for (i = 0; sequenceTests.length > i; i++) {
        if (sequenceTests[i] === d.testName && sequenceConditions[i] === d.conditionName) {
          sequenceTests.splice(i, 1);
          sequenceConditions.splice(i, 1);
          break;
        }
      }
    });

    if (!sequenceTests.length) {
      return false;
    }

    trialList.append('li').append('a').attr('class', 'sequence-incomplete-btn').text('Click to complete sequence').on('click', completeSequence);
    var list = $(trialList.node());
    list.slideDown();

    function completeSequence() {
      allTests.completedTests = completedTrials;
      allTests.pendingTests = [];

      for (i = 0; sequenceTests.length > i; i++) {
        var def = TestDefinitionHandler.getInstance().getTestDefinition(sequenceTests[i], sequenceConditions[i]);
        def.sequence = sequence;
        allTests.pendingTests.push(def);
      }

      checkConfiguration(function () {
        testSequenceBuilder.open(allTests, {
          isIncompleteSequence: true
        });
      });
    }

    return true;
  }
  /**
   * Create the table of all subjects for searching. Fires event when new subject
   * is selected and opens up the edit window for that subject. Also provides
   * search functionality.
   *
   * @param element
   *                The element to build the table inside of.
   */


  function buildSubjectsTable(element) {
    var subjects = currentStudyData.getAllSubjects();

    if (subjects.length <= 0) {
      element.append("p").attr("class", "instruction_normal").text("No subjects available.");
      return;
    } // Attach handler to the search box.


    d3.select("#subject-search-box").on("keyup", keyDown);
    var tableDiv = element.append("div");
    tableDiv.datum(subjects).call(subjectTable);
    /**
     * Filter and update based on values in search input boxes.
     */

    function keyDown() {
      var searchVal = d3.select("#subject-search-box").node().value;
      tableDiv.datum(filterSubjects(subjects, searchVal)).call(subjectTable);
    }
  }
  /**
   * Filter the given subjects using supplied filter.
   * @param {Array} subjects The array of subjects to filter.
   * @param {String} filter The filter string to use.
   * @return Array of subjects whose displayed fields match the filter.
   */


  function filterSubjects(subjects, filter) {
    var filterPat = new RegExp(filter, "gi");
    var filtered = [];
    subjects.forEach(function (d) {
      var displayed = UserOptionsHandler.getInstance().getPatientRequiredFields();

      if (displayed.id === true) {
        if (filterPat.test(d.getPublicId()) === true) {
          filtered.push(d);
        }
      }

      if (displayed.name === true) {
        if (filterPat.test(d.getLastName()) === true) {
          filtered.push(d);
        }

        if (filterPat.test(d.getFirstName()) === true) {
          filtered.push(d);
        }
      }

      if (displayed.birthDate === true) {
        if (filterPat.test(d.getDateOfBirthStr()) === true) {
          filtered.push(d);
        }
      }
    });
    return filtered;
  }
  /*******************************************************************************
   *
   * UI for test condition management
   *
   ******************************************************************************/

  /**
   * Build the condition tabs for each test.
   * @param {String} activeTest If supplied, the tab to have active.
   */


  function buildTestConditionTabs(activeTest) {
    // Remove sequences from the test types.
    var types = TestDefinitionHandler.getInstance().getTestNameMap();
    var tabList = $('#test-condition-tab-list');
    tabList.empty();
    var tabContent = $('#test-condition-tab-content');
    tabContent.empty();
    types.forEach(function (d) {
      var id = 'test-condition-tab-' + utils.makeHtmlId(d.name);
      tabList.append('<li><a href="#' + id + '" data-toggle="tab">' + d.displayName + '</a></li>');
      tabContent.append('<div id="' + id + '" class="tab-pane"></div>');
      buildSingleTestConditionTab(id, d);
    });

    if (LicenseHandler.getInstance().isResearchView() && canEditStudy) {
      tabList.append('<li><a id="test-condition-add-test-type-tab" ' + 'href="#test-condition-add-test-type" ' + 'data-toggle="tab">' + '<span class="plus-icon iconic iconic-plus">' + '</span>Add</a></li>');
      tabContent.append('<div id="test-condition-add-test-type" ' + 'class="tab-pane"></div>');
      $('#test-condition-add-test-type-tab').on('shown.bs.tab', function (evt) {
        $(evt.relatedTarget).tab('show');
        addTestType();
      });
    }

    var active = [];

    if (activeTest) {
      active = tabList.find('[href="#test-condition-tab-' + utils.makeHtmlId(activeTest) + '"]');
    }

    if (active.length) {
      active.tab('show');
    } else {
      tabList.find('a:first').tab('show');
    }
  }
  /**
   * Build the condition table and an 'add condition' and 'import
   * condition' buttons within the node within the supplied id for the
   * given test type.
   * @param id The node id to build content in.
   * @param {Object} testType Name and display name for the test.
   */


  function buildSingleTestConditionTab(id, testType) {
    var testDef = TestDefinitionHandler.getInstance().getAllSingleTestDefinitions(testType.name);
    var tab = d3.select('div #' + id); // Create the add/import condition buttons

    var btnDiv = tab.append('div').attr('class', 'padded-btn pull-right');
    var addBtn = btnDiv.append('button').attr('type', 'button').attr('class', 'btn btn-default has-modify-study').style('margin-right', '4px'); // Need to do this to get the space between

    addBtn.append('span').attr('class', 'plus-icon iconic iconic-plus');
    addBtn.append('span').text('Add Condition');
    addBtn.on('click', function () {
      addEditTestCondition.init(canEditStudy, id, {
        testName: testType.name,
        testDisplayName: testType.displayName
      });
    });

    if (!server.hasJsPostHandler()) {
      var importBtn = btnDiv.append('button').attr('type', 'button').attr('class', 'btn btn-default has-modify-study');
      importBtn.append('span').attr('class', 'plus-icon iconic iconic-data-transfer-download');
      importBtn.append('span').text('Import Condition');
      importBtn.on('click', function () {
        crossroads.parse('dispatch/importTestDefinition');
      });
    } // Disable add/import if can't edit study


    if (!canEditStudy) {
      $('.has-modify-study').attr('disabled', 'disabled');
    } // Build data structure for each table row.


    var rowData = Object.keys(testDef.conditions).map(function (d) {
      return testDef.conditions[d];
    }); // Build the condition table

    var colHeaders = ['Condition', 'Duration (s)', 'Countdown (s)', 'Color', 'View/Edit', 'Delete', 'Visible'];
    var table = tab.append('table').attr('class', 'tablesorter table sortable');
    var theadRow = table.append('thead').attr('class', 'reports_head_row').append('tr');
    theadRow.selectAll('th').data(colHeaders).enter().append('th').text(function (d) {
      return d;
    });
    var tbodyRows = table.append('tbody').selectAll('tr').data(rowData).enter().append('tr');
    tbodyRows.selectAll('td').data(function (d) {
      var duration = d.recordDuration;

      if (parseInt(duration, 10) === 0) {
        duration = 'Indeterminate';
      }

      var color = d.displayColor;

      if (!color || color === '') {
        color = '#4ac4d4';
      }

      var colorEntry = '<svg width="34" height="34">' + '<rect width="34" height="34" style="fill:' + color + '"</rect></svg>';
      return [d.conditionDisplayName, duration, d.startDelay, colorEntry, createConditionEditBtn(d), createConditionDeleteBtn(d), createVisibilityCheckbox(d)];
    }).enter().append('td').html(function (d) {
      return d;
    }); // Add a delete handler to each of the rows.

    tbodyRows.each(function (d) {
      d3.select(this).select('#delete-condition').on('click', function () {
        deleteConditionForTest(id, d);
      });
    }); // Add the edit handler

    tbodyRows.each(function (d) {
      d3.select(this).select('#edit-condition').on('click', function () {
        addEditTestCondition.init(canEditStudy, id, d);
      });
    }); // Add the visible handler

    tbodyRows.each(function (d) {
      d3.select(this).select('#visible-checkbox').on('click', function () {
        var disabledMap = UserOptionsHandler.getInstance().getDisabledTestConditions();
        var checked = $(this).prop('checked');

        if (checked === false) {
          if (disabledMap[d.testName]) {
            disabledMap[d.testName].push(d.conditionName);
          } else {
            disabledMap[d.testName] = [d.conditionName];
          }
        } else {
          if (disabledMap[d.testName]) {
            var idx = disabledMap[d.testName].indexOf(d.conditionName);

            if (idx > -1) {
              disabledMap[d.testName].splice(idx, 1);
            }
          }
        }

        UserOptionsHandler.getInstance().setDisabledTestConditions(disabledMap);
      });
    }); // Make the table sortable.

    theadRow.select('th').attr('data-defaultsort', 'asc');
    $.bootstrapSortable(true);
  }
  /**
   * Create an "edit" button for the test condition, if it is not
   * regestered as a "default" test condition.
   * @param testDefObj Object containing the test name and condition.
   * @return HTML for the edit button, if condition is not a default.
   */


  function createConditionEditBtn(testDefObj) {
    var testDefHandler = TestDefinitionHandler.getInstance();
    var defaultConditions = testDefHandler.getDefaultTestConditions(testDefObj.testName);
    var icon = 'iconic iconic-pencil';

    if (defaultConditions[testDefObj.conditionName] || !canEditStudy) {
      icon = 'iconic iconic-eye';
    }

    return '<button type="button" class="btn btn-default"' + ' id="edit-condition">' + '<span class="' + icon + '"></span></button>';
  }
  /**
   * Create a delete button for the test condition, if it is not
   * regestered as a "default" test condition.
   * @param {Object} testDefObj The test definition to edit.
   * @return {String} HTML for the delete button, if condition is not a default.
   */


  function createConditionDeleteBtn(testDefObj) {
    var testDefHandler = TestDefinitionHandler.getInstance();
    var defaultConditions = testDefHandler.getDefaultTestConditions(testDefObj.testName);
    var html = '--';

    if (!defaultConditions[testDefObj.conditionName] && canEditStudy) {
      html = '<button type="button" class="btn btn-default"' + ' id="delete-condition">' + '<span class="iconic iconic-trash"></span></button>';
    }

    return html;
  }
  /**
   * Create the visiblity checkbox and set to current value.
   * @param {Object} testDefObj The test definition.
   * @return {String} The HTML for the checkbox.
   */


  function createVisibilityCheckbox(testDef) {
    var disabledMap = UserOptionsHandler.getInstance().getDisabledTestConditions();
    var html;
    var disabled = disabledMap[testDef.testName];

    if (disabled && disabled.indexOf(testDef.conditionName) > -1) {
      html = '<input id="visible-checkbox" type="checkbox">';
    } else {
      html = '<input id="visible-checkbox" type="checkbox" checked>';
    }

    return html;
  }
  /**
   * Show a conformation dialog to the user, and if desired, make a
   * server call to delete the condition for the given test type.
   * @param {String} id The id of the tab the condition is displayed in.
   * @param {Object} testDef The test defintion to delete.
   */


  function deleteConditionForTest(id, testDef) {
    if (conditionUsed(testDef.testName, testDef.conditionName) === true) {
      ErrorHandler.showError('Cannot delete "' + testDef.conditionDisplayName + '", trials with this condition exist.');
      return;
    }

    deleteHandler.deleteTestDefinition(testDef, function () {
      var newDef = TestDefinitionHandler.getInstance().getTestDefinition(testDef.testName);

      if (!newDef) {
        buildTestConditionTabs();
        return;
      }

      $('#' + id).empty();
      buildSingleTestConditionTab(id, {
        name: newDef.testName,
        displayName: newDef.testDisplayName
      });
    });
  }
  /**
   * Check all the trials and see if any are using the given condition.
   *
   * @param {String}
   *                testType The test containing the condition.
   * @param {String}
   *                condition The name of the condition.
   * @return {Boolean} True if condition is being used, otherwise false.
   */


  function conditionUsed(testType, condition) {
    var testDef = TestDefinitionHandler.getInstance().getTestDefinition(testType, condition);
    return testDef.numberTrials > 0;
  }
  /**
   * Open dialog to create a new test type.
   */


  function addTestType() {
    var testOptions = {};
    var nameField = $('#add-test-type-name').val(null);
    nameField.attr('placeholder', 'Test Type Name');
    nameField.parent().removeClass('has-error');
    var dialog = $('#dialog-add-test-type').modal('show');
    $('#add-test-type-save-button').off('click').click(function () {
      var name = nameField.val();

      if (!validateTestName()) {
        return;
      }

      testOptions.isNewTestType = true;
      testOptions.testName = name; // TODO: Some day add support for these fields...

      testOptions.adminInstructionVideoPath = '';
      testOptions.subjectInstructionVideoPath = '';
      dialog.modal('hide');
      addEditTestCondition.init(canEditStudy, null, testOptions);
    });
  }
  /**
   * Make sure the name for the new test exists and doesn't conflict
   * with existing names.
   */


  function validateTestName() {
    var nameField = $('#add-test-type-name');
    var name = nameField.val();
    var existingTestTypes = TestDefinitionHandler.getInstance().getTestNameMap().map(function (d) {
      return d.name;
    });

    if (!name || name === '') {
      nameField.parent().addClass('has-error');
      nameField.attr('placeholder', 'Name is required');
      return false;
    } else if (existingTestTypes.indexOf(name) >= 0) {
      nameField.parent().addClass('has-error');
      nameField.attr('placeholder', 'Test with name "' + name + '" exists.');
      nameField.val(null);
      return false;
    } // Don't allow test names to confilct with sequence names.


    if (TestDefinitionHandler.getInstance().getSequenceDefinition(name)) {
      nameField.parent().addClass('has-error');
      nameField.attr('placeholder', 'Sequence with name "' + name + '" exists.');
      nameField.val(null);
      return false;
    }

    return true;
  }
  /**
   * build the table of custom test sequences defined by the user.
   * @param {String} id The id of the container to build the table in.
   */


  function buildCustomSequenceTable(id) {
    $(id).empty();
    var testDefHandler = TestDefinitionHandler.getInstance();
    var container = d3.select(id);
    var sequences = testDefHandler.getAllSequences(); // Disable add/import if user cannot edit study

    if (!canEditStudy) {
      $('.has-modify-study').attr('disabled', 'disabled');
    } // Add handler to "Add Sequence" and "Import Sequence" buttons.


    $('#add-custom-sequence-options').off('click');
    $('#add-custom-sequence-options').click(function () {
      testSequenceBuilder.open(null, {
        caller: 'customSequence'
      });
    });

    if (server.hasJsPostHandler()) {
      $('#import-custom-sequence-options').remove();
    } else {
      $('#import-custom-sequence-options').off('click');
      $('#import-custom-sequence-options').click(function () {
        crossroads.parse('dispatch/importTestSequence');
      });
    }

    if (!sequences || !Object.keys(sequences).length) {
      container.append('h4').text('No custom sequences defined.');
      return;
    }

    var colHeaders = ['Name', 'Number of Tests', 'View/Edit', 'Delete', 'Visible'];
    var rowData = Object.keys(sequences);
    var table = container.append('div').append('table').attr('class', 'tablesortable table sortable');
    var theadRow = table.append('thead').attr('class', 'reports_head_row').append('tr');
    theadRow.selectAll('th').data(colHeaders).enter().append('th').text(function (d) {
      return d;
    });
    var tbodyRows = table.append('tbody').selectAll('tr').data(rowData).enter().append('tr');
    tbodyRows.selectAll('td').data(function (d) {
      return [d, testDefHandler.getSequenceDefinitionAsTestList(d).length, createSequenceEditButton(d, canEditStudy), createSequenceDeleteButton(d, canEditStudy), createSequenceVisibilityCheckbox(d, canEditStudy)];
    }).enter().append('td').html(function (d) {
      return d;
    }); // Add the delete, edit, and visibility handlers.

    tbodyRows.each(function (d) {
      var row = d3.select(this);
      row.select('#delete-custom-sequence-' + utils.makeHtmlId(d)).on('click', function () {
        deleteHandler.deleteTestSequence(d);
      });
      row.select('#edit-custom-sequence-' + utils.makeHtmlId(d)).on('click', function () {
        testSequenceBuilder.open({
          pendingTests: testDefHandler.getSequenceDefinitionAsTestList(d),
          completedTests: [],
          sequence: null
        }, {
          caller: 'customSequence',
          isEdit: true,
          canEdit: canEditStudy,
          sequenceName: d
        });
      });
      var checkbox = row.select('#visible-checkbox');
      checkbox.on('click', function () {
        var disabled = UserOptionsHandler.getInstance().getDisabledTestSequences();
        var checked = $(this).prop('checked');

        if (checked === false) {
          disabled.push(d);
        } else {
          var idx = disabled.indexOf(d);

          if (idx > -1) {
            disabled.splice(idx, 1);
          }
        }

        UserOptionsHandler.getInstance().setDisabledTestSequences(disabled);
      });

      if (!canEditStudy) {
        checkbox.attr('disabled', 'disabled');
      }
    });
    table.select('th').attr('data-defaultsort', 'asc'); // Make the table sortable.

    $.bootstrapSortable(false); // Add handlers to add/remove crossroads hash listener

    $('#custom-sequence-options-tab').on('show.bs.tab', function () {
      // Rebuild sequence table, and reload the study
      crossroads.addRoute('testDefinitionsUpdated/testSequence', function () {
        buildCustomSequenceTable('#custom-sequence-table');
        currentStudyData = ModelDispatcher.getInstance().getCurrentStudy();
      });
    });
  }
  /**
   * Create the edit button for a given test sequence.
   * @param {String} name The name of the sequence.
   * @param {Boolean} canEditStudy True if user can edit study.
   * @return {String} The html for the button.
   */


  function createSequenceEditButton(name, canEditStudy) {
    var defaultSequences = Object.keys(TestDefinitionHandler.getInstance().getDefaultSequences());

    if (defaultSequences.indexOf(name) < 0 && canEditStudy) {
      return '<button type="button" class="btn btn-default"' + ' id="edit-custom-sequence-' + utils.makeHtmlId(name) + '"><span class="iconic iconic-pencil"></span></button>';
    }

    return '<button type="button" class="btn btn-default"' + ' id="edit-custom-sequence-' + utils.makeHtmlId(name) + '"><span class="iconic iconic-eye"></span></button>';
  }
  /**
   * Create the delete button for a given test sequence.
   * @param {String} name The name of the sequence.
   * @param {Boolean} canEditStudy True if user can edit study.
   * @return {String} The html for the button.
   */


  function createSequenceDeleteButton(name, canEditStudy) {
    var defaultSequences = Object.keys(TestDefinitionHandler.getInstance().getDefaultSequences());

    if (defaultSequences.indexOf(name) < 0 && canEditStudy) {
      return '<button type="button" class="btn btn-default"' + ' id="delete-custom-sequence-' + utils.makeHtmlId(name) + '"><span class="iconic iconic-trash"></span></button>';
    }

    return '--';
  }
  /**
   * Create the visibility checkbox for a given test sequence.
   * @param {String} name The name of the sequence.
   * @param {Boolean} canEditStudy True if user can edit study.
   * @return {String} The html for the button.
   */


  function createSequenceVisibilityCheckbox(name) {
    var disabledSequences = UserOptionsHandler.getInstance().getDisabledTestSequences();
    var html = '<input id="visible-checkbox" type="checkbox">';

    if (disabledSequences.indexOf(name) === -1) {
      html = '<input id="visible-checkbox" type="checkbox" checked>';
    }

    return html;
  }
  /**
   * Create a "wait spinner" in the given div container and show it.
   * Responsibility of caller to shutdown spinner when not being used.
   * @param divId The id of div container to place spinner in.
   * @return The spinner instance.
   */


  function getWaitSpinner(divId) {
    var cl = new CanvasLoader(divId);
    cl.setColor('#009fbf');
    cl.setDiameter(64);
    cl.setDensity(103);
    cl.setRange(1);
    cl.setFPS(33);
    cl.show();
    return cl;
  }

  return {
    startMain: startMain
  };
});
//# sourceMappingURL=mobility_clinic_main.js.map
