"use strict";

/* Copyright (c) 2018 APDM, Inc.
 *
 * simulate_drap_and_drop.js
 *
 */
define([], function () {
  var simulateDragDrop = function simulateDragDrop(source, target) {
    simulateEvent(source[0], target[0]);
  };

  function simulateEvent(source, target) {
    /*Simulating drag start*/
    var type = 'dragstart';
    var event = createEvent(source, type);
    dispatchEvent(source, type, event);
    /*Simulating drop*/

    type = 'drop';
    var dropEvent = createEvent(source, type);
    dropEvent.dataTransfer = event.dataTransfer;
    dispatchEvent(target, type, dropEvent);
    /*Simulating drag end*/

    type = 'dragend';
    var dragEndEvent = createEvent(source, type);
    dragEndEvent.dataTransfer = event.dataTransfer;
    dispatchEvent(target, type, dragEndEvent);
  }

  function createEvent(source, type) {
    var event = document.createEvent("CustomEvent");
    event.initCustomEvent(type, true, true, null);
    event.dataTransfer = {
      data: {},
      setData: function setData(type, val) {
        this.data[type] = val;
      },
      getData: function getData(type) {
        return this.data[type];
      }
    };
    return event;
  }

  function dispatchEvent(elem, type, event) {
    if (elem.dispatchEvent) {
      elem.dispatchEvent(event);
    } else if (elem.fireEvent) {
      elem.fireEvent("on" + type, event);
    }
  } // Make visible globably


  window.simulateDragDrop = simulateDragDrop;
});
//# sourceMappingURL=simulate_drag_and_drop.js.map
