/* Copyright (c) 2016 APDM, Inc.
 *
 * report_enums.js
 *
 * Enums used for determining types for visualizations, tables, and filters
 * within reports.
 */

define({
    /**
     * Enum for table and visualiztion types
     */
    reportType: {
        table: {
            NONE: 0,
            METRICS_DETAIL: 1,
            METRICS_OVERVIEW: 2,
            METRICS_OVERVIEW_SD: 3
        },

        vis: {
            NONE: 0,
            METRIC_VIS: 1,
            METRIC_LONGITUDINAL: 2,
            METRIC_BAR_COMPARISON: 3,
            SEQUENCE_VIS: 4,
            JOINT_ANGLE_VARIABILITY: 5
        }
    },

    /**
     * Enum to specify how trials should be filtered for comparison.
     */
    filterType: {
        ALL: 0,
        CONDITION: 1,
        SEQUENCE: 2,
        DAY: 3
    },

    /**
     * Types of visualizations to display for a metric.
     */
    metricVisType: {
        NONE: 0,
        APDM_VIS: 1,
        STABILOGRAM: 2,
        EVENT_PLOT: 3
    }
 });
